/*
 The software in this package is distributed under the GNU General
 Public License version 2 (with a special exception described below).

 A copy of GNU General Public License (GPL) is included in this distribution,
 in the file COPYING.GPL.

 As a special exception, if other files instantiate templates or use macros
 or inline functions from this file, or you compile this file and link it
 with other works to produce a work based on this file, this file
 does not by itself cause the resulting work to be covered
 by the GNU General Public License.

 However the source code for this file must still be made available
 in accordance with section (3) of the GNU General Public License.

 This exception does not invalidate any other reasons why a work based
 on this file might be covered by the GNU General Public License.

 Christian Herdtweck, Intra2net AG 2015
 */

#ifndef IPHEADER_H
#define IPHEADER_H

#include <stdint.h>
#include <istream>
#include <boost/shared_ptr.hpp>
#include <boost/asio/ip/address.hpp>

/**
 * abstract base class of IPv4Header and IPv6Header
 */
class IpHeader
{
public:
    virtual boost::asio::ip::address get_source_address() const = 0;
    virtual boost::asio::ip::address get_destination_address() const = 0;
    virtual uint8_t get_version() const = 0;
    virtual uint16_t get_header_length() const = 0;
    virtual uint8_t get_time_to_live() const = 0;
    virtual uint16_t get_total_length() const = 0;

    virtual ~IpHeader() {}

};

typedef boost::shared_ptr<IpHeader> IpHeaderPtr;

#endif

// (created using vim -- the world's best text editor)

